//jsSignatureStart%92rS%ca%c4~%f2%a1%13Bd1*l>3%b6;z%c9oT%98wY%9bA\%0eM>%f9%bf%c5%b28%b2%f8%12EGsl9%83s%eeJ%8d%08%04%85%11=%c5%ec%98Lk%25%f4%e11R2%e3x%f0%db6&T9383?%caQ%c6z>%dfc%c6#%0dB{%b4xtr}%f2%96%d5%9a%1f%1cAS%d9fE%db%ce%0bw%ea!%0a%ecPM%bfs%c0%e1O%ab)%c8%c7%86%f7%a4%e6
/* Configure.js
 * CR3 configuration utility
 *
 * $Source: /cygdrive/c/working/CodeCorp/Flipper/firmware/shared/jse/RCS/configure.js,v $
 * $Revision: 1.67 $
 * $State: Exp $
 * $Name:  $
 *
 */



include(".settings.js");



/* registers 
 */
var commProtocol    = 0x08;

var comm_version0   =  0;
var comm_raw        =  1;
var comm_version1   =  2;


var commMode        = 0x1B;

var comm_kb         =  0;
var comm_uart       =  1;
var comm_usbKb      =  2;
var comm_usbIbm     =  3;
var comm_rf         =  4;
var comm_usbNative  =  5;
var comm_usbVcom    =  6;

var commExpectResponse = 0x42;

var rfMinLinkQuality_fp24_8 = 0xb2;

var button1 = 0x39;     // right button
var button2 = 0x3a;     // left button
var button4 = 0x3c;     // handle button

var sxgaBoth = 0x1c;
var sxgaNear = 0x1d;
var sxgaFar = 0x1e;
var vgaBoth = 0x1f;
var vgaNear = 0x20;
var vgaFar = 0x21;
var adaptiveBoth = 0x22;
var adaptiveNear = 0x23;
var adaptiveFar = 0x24;

/* menus
 */
main = new gui.Menu();

main.app = new gui.Menu();
main.app.options = new gui.Menu();

main.comm = new gui.Menu();
main.comm.interfaces = new gui.Menu();

main.info = new gui.Menu();

main.optimization = new gui.Menu();

main.system = new gui.Menu();



// todo dialog (indicates missing features)
function todo(s)
{
    alert("TODO: " + s);
}



// app
main.app.currentFile = new String();

main.app.options.version_onClick = function()
{
    var re = new RegExp("\\$" + "Revision: .*\\$"); // separate $ and Version to avoid RCS keyword substitution
    var file = storage.read(main.app.currentFile);
   
    var ret = file.match(re);
    if( ret == null )
    {
        ret = "Unknown version";
    }
    else
    {
        ret = ret.toString();    
        ret = ret.substr(1, ret.length - 1 - 2/* $*/);
    }

    dialog = new gui.Text(ret);
    dialog.caption = main.app.currentFile;
    dialog.onCancel = function() { gui.showSubMenu(main.app.options, main.app); }
    dialog.onOk = dialog.onCancel;
    dialog.leftSoftkey = new gui.Softkey("OK", dialog.onCancel);

    gui.showDialog(dialog);
}

main.app.options.append( new gui.MenuItem("Run",        function() { if( !reader.runScript(main.app.currentFile) ) alert("Run script failed!"); }) );
main.app.options.append( new gui.MenuItem("Version",    main.app.options.version_onClick) );
if( !reader.readSetting(setting_disableDeleteOption) ) 
    main.app.options.append( new gui.MenuItem("Delete",     function() { if( gui.confirm("Are you sure?") ) {storage.erase(main.app.currentFile); reader.runScript(".configure.js");}}) );
main.app.options.append( new gui.MenuItem("Set as default",function() { storage.write(".default.js", "include(\"" + main.app.currentFile + "\");"); reader.runScript(".default.js");}) );

main.app_onClick = function() 
{ 
    main.app.options.caption = this.text;
    main.app.currentFile = main.app.appArray[main.app.titleArray.indexOf(this.text)];
    gui.showSubMenu(main.app.options, main.app) 
}

main.app.caption = "Applications";
main.app.appArray = new Array();
main.app.titleArray = new Array();
var app = storage.findFirst(/^[^.].+\.js$/);
if( app != null )
{
    main.app.appArray.push(app);
    while( (app = storage.findNext()) != null )
    {
        main.app.appArray.push(app);
    }        
    
    //Parse for title keyword and add to appArray for sorting
    for( var i = 0; i < main.app.appArray.length; i++ )
    {
        var re = new RegExp("\\$" + "Title: .*\\$"); // separate $ and Version to avoid RCS keyword substitution
        var file = storage.read(main.app.appArray[i]);

        var ret = file.match(re);
        if( ret == null )
        {
            ret = main.app.appArray[i];
        }
        else
        {
            ret = ret.toString();
            ret = ret.replace(/\$|Title: /g, "");
        }

        main.app.appArray[i] = ret + "\x1e" + main.app.appArray[i];
    }

    //sort by title
    main.app.appArray.sort();
    
    //Split appArray into title array and appArray
    for( var j = 0; j < main.app.appArray.length; j++ )
    {
        main.app.titleArray[j] = main.app.appArray[j].substring(0, main.app.appArray[j].indexOf("\x1e"));
        main.app.appArray[j] = main.app.appArray[j].replace(/^.+\x1e/, "");
    }

    //Display titles on form
    for( var k = 0; k < main.app.titleArray.length; k++ )
        main.app.append( new gui.MenuItem(main.app.titleArray[k], main.app_onClick) );
}    



// comm
main.comm.interfaces.promptSaveSetting = function(initItemText)
{
    if( gui.confirm("Settings changed.\n\nSave now?") )
    {
        reader.saveSettings();
        reader.runScript(".default.js");
    }
    else
    {
        initItemText();
        main.comm.interfaces.initItemText();
    }
}

main.comm.interfaces.ps2_onClick = function()
{
    reader.processCommand("P", String.fromCharCode(commProtocol) + comm_raw);
    reader.processCommand("P", String.fromCharCode(commMode) + comm_kb);
    reader.processCommand("P", String.fromCharCode(commExpectResponse) + "0");
    main.comm.interfaces.promptSaveSetting(main.comm.interfaces.initItemText);
}

include(".configure_main_comm_interface_usb.js");

main.comm.interfaces.usb_onClick = function()
{
    main.comm.interfaces.usb.initItemText();
    
    main.comm.interfaces.usb.caption = "USB";
    gui.showSubMenu(main.comm.interfaces.usb, main.comm.interfaces);
}

include(".configure_main_comm_interface_rf.js");

main.comm.interfaces.rf_onClick = function()
{
    main.comm.interfaces.rf.initItemText();
    
    main.comm.interfaces.rf.caption = "RF";
    gui.showSubMenu(main.comm.interfaces.rf, main.comm.interfaces);
}

include(".configure_main_comm_interface_rs232.js");

main.comm.interfaces.rs232_onClick = function()
{
    main.comm.interfaces.rs232.initItemText();
    main.comm.interfaces.rs232.caption = "RS232";
    gui.showSubMenu(main.comm.interfaces.rs232, main.comm.interfaces);
}

main.comm.interfaces.ps2Item      = new gui.MenuItem("", main.comm.interfaces.ps2_onClick);
main.comm.interfaces.usbItem      = new gui.MenuItem("", main.comm.interfaces.usb_onClick);
main.comm.interfaces.rfItem       = new gui.MenuItem("", main.comm.interfaces.rf_onClick);
main.comm.interfaces.rs232Item    = new gui.MenuItem("", main.comm.interfaces.rs232_onClick);

main.comm.interfaces.initItemText = function()
{
    switch( reader.readSetting(commMode) )
    {
    case comm_kb:
        main.comm.interfaces.ps2Item.text        = "*"    + "PS/2 KB";
        main.comm.interfaces.usbItem.text        = "\x1f" + "USB";
        main.comm.interfaces.rfItem.text         = "\x1f" + "RF";
        main.comm.interfaces.rs232Item.text      = "\x1f" + "RS-232";
        break;
        
    case comm_usbKb:
    case comm_usbIbm:
    case comm_usbNative:
    case comm_usbVcom:
        main.comm.interfaces.ps2Item.text        = "\x1f" + "PS/2 KB";
        main.comm.interfaces.usbItem.text        = "*"    + "USB";
        main.comm.interfaces.rfItem.text         = "\x1f" + "RF";
        main.comm.interfaces.rs232Item.text      = "\x1f" + "RS-232";
        break;
        
    case comm_uart:
        main.comm.interfaces.ps2Item.text        = "\x1f" + "PS/2 KB";
        main.comm.interfaces.usbItem.text        = "\x1f" + "USB";
        main.comm.interfaces.rfItem.text         = "\x1f" + "RF";
        main.comm.interfaces.rs232Item.text      = "*"    + "RS-232";
        break;
        
    case comm_rf:
        main.comm.interfaces.ps2Item.text        = "\x1f" + "PS/2 KB";
        main.comm.interfaces.usbItem.text        = "\x1f" + "USB";
        main.comm.interfaces.rfItem.text         = "*"    + "RF";
        main.comm.interfaces.rs232Item.text      = "\x1f" + "RS-232";
        break;
        
    }
}

main.comm.interfaces.append(main.comm.interfaces.ps2Item);
main.comm.interfaces.append(main.comm.interfaces.usbItem);
if( reader.bdAddr != "none" )
    main.comm.interfaces.append(main.comm.interfaces.rfItem);
main.comm.interfaces.append(main.comm.interfaces.rs232Item);
    
main.comm.interfaces_onClick = function() 
{
    main.comm.interfaces.initItemText();

    main.comm.interfaces.caption = "Communication";
    gui.showSubMenu(main.comm.interfaces, main);    
}

main.comm.caption = "Communication";
main.comm.append( new gui.MenuItem("Interface", main.comm.interfaces_onClick) );



// info
main.info.showDialog = function(dialog, caption)
{
    dialog.caption = caption;
    dialog.onCancel = function() { gui.showSubMenu(main.info, main); };
    dialog.onOk = dialog.onCancel;
    dialog.leftSoftkey = new gui.Softkey("OK", dialog.onCancel);

    gui.showDialog(dialog);
}

main.info.readerId_onClick = function()
{
    dialog = new gui.Text(reader.readerId);
    main.info.showDialog(dialog, this.text)
}

main.info.version_onClick = function()
{
    dialog = new gui.Text("App:     " +  reader.softwareVersion.substr(0, 4) + "\n" 
                        + "Boot:    " + reader.softwareVersion.substr(4, 4) + "\n"
                        + "Radio:   " + reader.softwareVersion.substr(8, 4) + "\n"
                        + "OEM ID: " + reader.oemId);
    main.info.showDialog(dialog, this.text)
}

main.info.time_onClick = function()
{
    dialog = new gui.Text(Date().substr(0, 24));    // no time zone
    main.info.showDialog(dialog, this.text)
}

main.info.bdAddr_onClick= function()
{
    dialog = new gui.Text(reader.bdAddr != "none"? reader.bdAddr: "No radio");
    main.info.showDialog(dialog, this.text)
}

main.info.caption = "Reader Info";
main.info.append( new gui.MenuItem("Firmware Ver:", main.info.version_onClick) );
main.info.append( new gui.MenuItem("Reader Serial #", main.info.readerId_onClick) );
main.info.append( new gui.MenuItem("Date/Time", main.info.time_onClick) );
main.info.append( new gui.MenuItem("Radio BD_ADDR", main.info.bdAddr_onClick) );



// optimization
main.optimization.sxgaBothField_onClick = function()
{
    reader.processCommand("P", String.fromCharCode(button1) + "#" + sxgaBoth);
    reader.processCommand("P", String.fromCharCode(button2) + "#" + sxgaBoth);
    reader.processCommand("P", String.fromCharCode(button4) + "#" + sxgaBoth);
    main.optimization.initItemText();
}

main.optimization.sxgaNearField_onClick = function()
{
    reader.processCommand("P", String.fromCharCode(button1) + "#" + sxgaNear);
    reader.processCommand("P", String.fromCharCode(button2) + "#" + sxgaNear);
    reader.processCommand("P", String.fromCharCode(button4) + "#" + sxgaNear);
    main.optimization.initItemText();
}

main.optimization.sxgaFarField_onClick = function()
{
    reader.processCommand("P", String.fromCharCode(button1) + "#" + sxgaFar);
    reader.processCommand("P", String.fromCharCode(button2) + "#" + sxgaFar);
    reader.processCommand("P", String.fromCharCode(button4) + "#" + sxgaFar);
    main.optimization.initItemText();
}

main.optimization.vgaBothField_onClick = function()
{
    reader.processCommand("P", String.fromCharCode(button1) + "#" + vgaBoth);
    reader.processCommand("P", String.fromCharCode(button2) + "#" + vgaBoth);
    reader.processCommand("P", String.fromCharCode(button4) + "#" + vgaBoth);
    main.optimization.initItemText();
}

main.optimization.vgaNearField_onClick = function()
{
    reader.processCommand("P", String.fromCharCode(button1) + "#" + vgaNear);
    reader.processCommand("P", String.fromCharCode(button2) + "#" + vgaNear);
    reader.processCommand("P", String.fromCharCode(button4) + "#" + vgaNear);
    main.optimization.initItemText();
}

main.optimization.vgaFarField_onClick = function()
{
    reader.processCommand("P", String.fromCharCode(button1) + "#" + vgaFar);
    reader.processCommand("P", String.fromCharCode(button2) + "#" + vgaFar);
    reader.processCommand("P", String.fromCharCode(button4) + "#" + vgaFar);
    main.optimization.initItemText();
}

main.optimization.adaptiveBothField_onClick = function()
{
    reader.processCommand("P", String.fromCharCode(button1) + "#" + adaptiveBoth);
    reader.processCommand("P", String.fromCharCode(button2) + "#" + adaptiveBoth);
    reader.processCommand("P", String.fromCharCode(button4) + "#" + adaptiveBoth);
    main.optimization.initItemText();
}

main.optimization.adaptiveNearField_onClick = function()
{
    reader.processCommand("P", String.fromCharCode(button1) + "#" + adaptiveNear);
    reader.processCommand("P", String.fromCharCode(button2) + "#" + adaptiveNear);
    reader.processCommand("P", String.fromCharCode(button4) + "#" + adaptiveNear);
    main.optimization.initItemText();
}

main.optimization.adaptiveFarField_onClick = function()
{
    reader.processCommand("P", String.fromCharCode(button1) + "#" + adaptiveFar);
    reader.processCommand("P", String.fromCharCode(button2) + "#" + adaptiveFar);
    reader.processCommand("P", String.fromCharCode(button4) + "#" + adaptiveFar);
    main.optimization.initItemText();
}

main.optimization.sxgaBothFieldItem = new gui.MenuItem("SXGA Both", main.optimization.sxgaBothField_onClick);
main.optimization.sxgaNearFieldItem = new gui.MenuItem("SXGA Near", main.optimization.sxgaNearField_onClick);
main.optimization.sxgaFarFieldItem = new gui.MenuItem("SXGA Far", main.optimization.sxgaFarField_onClick);
main.optimization.vgaBothFieldItem = new gui.MenuItem("VGA Both", main.optimization.vgaBothField_onClick);
main.optimization.vgaNearFieldItem = new gui.MenuItem("VGA Near", main.optimization.vgaNearField_onClick);
main.optimization.vgaFarFieldItem = new gui.MenuItem("VGA Far", main.optimization.vgaFarField_onClick);
main.optimization.adaptiveBothFieldItem = new gui.MenuItem("DOT Both", main.optimization.adaptiveBothField_onClick);
main.optimization.adaptiveNearFieldItem = new gui.MenuItem("DOT Near", main.optimization.adaptiveNearField_onClick);
main.optimization.adaptiveFarFieldItem = new gui.MenuItem("DOT Far", main.optimization.adaptiveFarField_onClick);

main.optimization.append(main.optimization.sxgaBothFieldItem);
main.optimization.append(main.optimization.sxgaNearFieldItem);
main.optimization.append(main.optimization.sxgaFarFieldItem);
main.optimization.append(main.optimization.vgaBothFieldItem);
main.optimization.append(main.optimization.vgaNearFieldItem);
main.optimization.append(main.optimization.vgaFarFieldItem);
main.optimization.append(main.optimization.adaptiveBothFieldItem);
main.optimization.append(main.optimization.adaptiveNearFieldItem);
main.optimization.append(main.optimization.adaptiveFarFieldItem);

main.optimization.initItemText = function()
{
    switch( reader.readSetting(button4) )
    {
    case sxgaBoth:
        main.optimization.sxgaBothFieldItem.text        = "*"       + "SXGA Both";
        main.optimization.sxgaNearFieldItem.text        = "\x1f"    + "SXGA Near";
        main.optimization.sxgaFarFieldItem.text         = "\x1f"    + "SXGA Far";
        main.optimization.vgaBothFieldItem.text         = "\x1f"    + "VGA Both";
        main.optimization.vgaNearFieldItem.text         = "\x1f"    + "VGA Near";
        main.optimization.vgaFarFieldItem.text          = "\x1f"    + "VGA Far";
        main.optimization.adaptiveBothFieldItem.text    = "\x1f"    + "DOT Both";
        main.optimization.adaptiveNearFieldItem.text    = "\x1f"    + "DOT Near";
        main.optimization.adaptiveFarFieldItem.text     = "\x1f"    + "DOT Far";
        break;
        
    case sxgaNear:
        main.optimization.sxgaBothFieldItem.text        = "\x1f"    + "SXGA Both";
        main.optimization.sxgaNearFieldItem.text        = "*"       + "SXGA Near";
        main.optimization.sxgaFarFieldItem.text         = "\x1f"    + "SXGA Far";
        main.optimization.vgaBothFieldItem.text         = "\x1f"    + "VGA Both";
        main.optimization.vgaNearFieldItem.text         = "\x1f"    + "VGA Near";
        main.optimization.vgaFarFieldItem.text          = "\x1f"    + "VGA Far";
        main.optimization.adaptiveBothFieldItem.text    = "\x1f"    + "DOT Both";
        main.optimization.adaptiveNearFieldItem.text    = "\x1f"    + "DOT Near";
        main.optimization.adaptiveFarFieldItem.text     = "\x1f"    + "DOT Far";
        break;
        
    case sxgaFar:
        main.optimization.sxgaBothFieldItem.text        = "\x1f"    + "SXGA Both";
        main.optimization.sxgaNearFieldItem.text        = "\x1f"    + "SXGA Near";
        main.optimization.sxgaFarFieldItem.text         = "*"       + "SXGA Far";
        main.optimization.vgaBothFieldItem.text         = "\x1f"    + "VGA Both";
        main.optimization.vgaNearFieldItem.text         = "\x1f"    + "VGA Near";
        main.optimization.vgaFarFieldItem.text          = "\x1f"    + "VGA Far";
        main.optimization.adaptiveBothFieldItem.text    = "\x1f"    + "DOT Both";
        main.optimization.adaptiveNearFieldItem.text    = "\x1f"    + "DOT Near";
        main.optimization.adaptiveFarFieldItem.text     = "\x1f"    + "DOT Far";
        break;
        
    case vgaBoth:
        main.optimization.sxgaBothFieldItem.text        = "\x1f"    + "SXGA Both";
        main.optimization.sxgaNearFieldItem.text        = "\x1f"    + "SXGA Near";
        main.optimization.sxgaFarFieldItem.text         = "\x1f"    + "SXGA Far";
        main.optimization.vgaBothFieldItem.text         = "*"       + "VGA Both";
        main.optimization.vgaNearFieldItem.text         = "\x1f"    + "VGA Near";
        main.optimization.vgaFarFieldItem.text          = "\x1f"    + "VGA Far";
        main.optimization.adaptiveBothFieldItem.text    = "\x1f"    + "DOT Both";
        main.optimization.adaptiveNearFieldItem.text    = "\x1f"    + "DOT Near";
        main.optimization.adaptiveFarFieldItem.text     = "\x1f"    + "DOT Far";
        break;
        
    case vgaNear:
        main.optimization.sxgaBothFieldItem.text        = "\x1f"    + "SXGA Both";
        main.optimization.sxgaNearFieldItem.text        = "\x1f"    + "SXGA Near";
        main.optimization.sxgaFarFieldItem.text         = "\x1f"    + "SXGA Far";
        main.optimization.vgaBothFieldItem.text         = "\x1f"    + "VGA Both";
        main.optimization.vgaNearFieldItem.text         = "*"       + "VGA Near";
        main.optimization.vgaFarFieldItem.text          = "\x1f"    + "VGA Far";
        main.optimization.adaptiveBothFieldItem.text    = "\x1f"    + "DOT Both";
        main.optimization.adaptiveNearFieldItem.text    = "\x1f"    + "DOT Near";
        main.optimization.adaptiveFarFieldItem.text     = "\x1f"    + "DOT Far";
        break;
        
    case vgaFar:
        main.optimization.sxgaBothFieldItem.text        = "\x1f"    + "SXGA Both";
        main.optimization.sxgaNearFieldItem.text        = "\x1f"    + "SXGA Near";
        main.optimization.sxgaFarFieldItem.text         = "\x1f"    + "SXGA Far";
        main.optimization.vgaBothFieldItem.text         = "\x1f"    + "VGA Both";
        main.optimization.vgaNearFieldItem.text         = "\x1f"    + "VGA Near";
        main.optimization.vgaFarFieldItem.text          = "*"       + "VGA Far";
        main.optimization.adaptiveBothFieldItem.text    = "\x1f"    + "DOT Both";
        main.optimization.adaptiveNearFieldItem.text    = "\x1f"    + "DOT Near";
        main.optimization.adaptiveFarFieldItem.text     = "\x1f"    + "DOT Far";
        break;
        
    case adaptiveBoth:
        main.optimization.sxgaBothFieldItem.text        = "\x1f"    + "SXGA Both";
        main.optimization.sxgaNearFieldItem.text        = "\x1f"    + "SXGA Near";
        main.optimization.sxgaFarFieldItem.text         = "\x1f"    + "SXGA Far";
        main.optimization.vgaBothFieldItem.text         = "\x1f"    + "VGA Both";
        main.optimization.vgaNearFieldItem.text         = "\x1f"    + "VGA Near";
        main.optimization.vgaFarFieldItem.text          = "\x1f"    + "VGA Far";
        main.optimization.adaptiveBothFieldItem.text    = "*"       + "DOT Both";
        main.optimization.adaptiveNearFieldItem.text    = "\x1f"    + "DOT Near";
        main.optimization.adaptiveFarFieldItem.text     = "\x1f"    + "DOT Far";
        break;
        
    case adaptiveNear:
        main.optimization.sxgaBothFieldItem.text        = "\x1f"    + "SXGA Both";
        main.optimization.sxgaNearFieldItem.text        = "\x1f"    + "SXGA Near";
        main.optimization.sxgaFarFieldItem.text         = "\x1f"    + "SXGA Far";
        main.optimization.vgaBothFieldItem.text         = "\x1f"    + "VGA Both";
        main.optimization.vgaNearFieldItem.text         = "\x1f"    + "VGA Near";
        main.optimization.vgaFarFieldItem.text          = "\x1f"    + "VGA Far";
        main.optimization.adaptiveBothFieldItem.text    = "\x1f"    + "DOT Both";
        main.optimization.adaptiveNearFieldItem.text    = "*"       + "DOT Near";
        main.optimization.adaptiveFarFieldItem.text     = "\x1f"    + "DOT Far";
        break;
        
    case adaptiveFar:
        main.optimization.sxgaBothFieldItem.text        = "\x1f"       + "SXGA Both";
        main.optimization.sxgaNearFieldItem.text        = "\x1f"    + "SXGA Near";
        main.optimization.sxgaFarFieldItem.text         = "\x1f"    + "SXGA Far";
        main.optimization.vgaBothFieldItem.text         = "\x1f"    + "VGA Both";
        main.optimization.vgaNearFieldItem.text         = "\x1f"    + "VGA Near";
        main.optimization.vgaFarFieldItem.text          = "\x1f"    + "VGA Far";
        main.optimization.adaptiveBothFieldItem.text    = "\x1f"    + "DOT Both";
        main.optimization.adaptiveNearFieldItem.text    = "\x1f"    + "DOT Near";
        main.optimization.adaptiveFarFieldItem.text     = "*"       + "DOT Far";
        break;
        
    default: 
        main.optimization.sxgaBothFieldItem.text        = "\x1f"    + "SXGA Both";
        main.optimization.sxgaNearFieldItem.text        = "\x1f"    + "SXGA Near";
        main.optimization.sxgaFarFieldItem.text         = "\x1f"    + "SXGA Far";
        main.optimization.vgaBothFieldItem.text         = "\x1f"    + "VGA Both";
        main.optimization.vgaNearFieldItem.text         = "\x1f"    + "VGA Near";
        main.optimization.vgaFarFieldItem.text          = "\x1f"    + "VGA Far";
        main.optimization.adaptiveBothFieldItem.text    = "\x1f"    + "DOT Both";
        main.optimization.adaptiveNearFieldItem.text    = "\x1f"    + "DOT Near";
        main.optimization.adaptiveFarFieldItem.text     = "\x1f"    + "DOT Far";
        break;
    
        
    }        
}

main.optimization.caption = "Optimization";
main.optimization_onClick = function() 
{
    main.optimization.initItemText();

    gui.showSubMenu(main.optimization, main); 
}




// system
main.system.backlightTime_onClick = function()
{
    form = new gui.Form();
    
    form.caption = "Backlight ms"
    
    form.time = new gui.Edit(reader.readSetting(0x0100).toString());
    
    form.append( new gui.Label("Set new value") );
    form.append(form.time);

    form.onOk = function() 
    {
        reader.writeSetting(0x0100, parseInt(form.time.text, 10));
        gui.showSubMenu(main.system, main);
    }

    form.onCancel = function()
    {
        gui.showSubMenu(main.system, main);
    }

    gui.showForm(form);
}

main.system.setDateTime_onClick = function()
{
    form = new gui.Form();
    
    form.caption = "Set date/time "
    
    d = new Date();

    var month = new String();
    var day = new String();
    var hour = new String();
    var minute = new String();
    var second = new String();
    
    month = (d.getMonth() + 1).toString();
    if( month.length < 2 )
        month = "0" + month;
        
    day = d.getDate().toString();
    if( day.length < 2 )
        day = "0" + day;        

    hour = d.getHours().toString();
    if( hour.length < 2 )
        hour = "0" + hour;        

    minute = d.getMinutes().toString();
    if( minute.length < 2 )
        minute = "0" + minute;        

    second = d.getSeconds().toString();
    if( second.length < 2 )
        second = "0" + second;        

    form.year = new gui.Edit(d.getFullYear().toString());
    form.month = new gui.Edit(month);
    form.day = new gui.Edit(day);
    form.hour = new gui.Edit(hour);
    form.minute = new gui.Edit(minute);
    form.second = new gui.Edit(second);

    form.append( new gui.Label("Year(4 digit)") );
    form.append(form.year);
    form.append( new gui.Label("Month(2 digit)") );
    form.append(form.month);
    form.append( new gui.Label("Day(2 digit)") );
    form.append(form.day);
    form.append( new gui.Label("Hour(24)(2 digit)") );
    form.append(form.hour);
    form.append( new gui.Label("Minute(2 digit)") );
    form.append(form.minute);
    form.append( new gui.Label("Second(2 digit)") );
    form.append(form.second);

    form.onOk = function() 
    {
        var re4 = new RegExp("^\\d{4}$");
        var re2 = new RegExp("^\\d{2}$");

        if( !re4.test(form.year.text) 
         || !re2.test(form.month.text) 
         || !re2.test(form.day.text) 
         || !re2.test(form.hour.text) 
         || !re2.test(form.minute.text) 
         || !re2.test(form.second.text) 
         )
        {
            gui.alert("Incorrect format!");
        }
        else
        {
            reader.processCommand("@", form.year.text + form.month.text + form.day.text + form.hour.text + form.minute.text + form.second.text);

            gui.showSubMenu(main.system, main);
        }
    }

    form.onCancel = function()
    {
        gui.showSubMenu(main.system, main);
    }

    gui.showForm(form);
}

main.system.saveSettings_onClick = function()
{
    if( gui.confirm("Are you sure you want to save settings?") )
    {
        reader.saveSettings();
        gui.showSubMenu(main.system, main);
    }
}

main.system.factoryDefault_onClick = function()
{
    if( gui.confirm("Are you sure you want to reset to factory defaults?") )
    {
        reader.defaultSettings();
        
        if( gui.confirm("Settings reset.\n\nSave now?") )
        {
            reader.saveSettings();
            reader.runScript(".default.js");
        }
        else
        {
            gui.showSubMenu(main.system, main);
        }
    }
}


main.system.caption = "System";
main.system.append( new gui.MenuItem("Backlight time", main.system.backlightTime_onClick) );
main.system.append( new gui.MenuItem("Set date/time", main.system.setDateTime_onClick) );
main.system.append( new gui.MenuItem("Save settings", main.system.saveSettings_onClick) );
main.system.append( new gui.MenuItem("Reset defaults", main.system.factoryDefault_onClick) );

notification = new gui.Text("");
notification.leftSoftkey = new gui.Softkey("Ok",  function() { gui.showMenu(main); });

notification.show = function(text)
{
    this.text = text? text: "Ready";
    gui.showDialog(this);
}


var lastCmdType = "";
var lastCmdData = "";

reader.onCommand = function(type, data)
{
    lastCmdType = type;
    lastCmdData = data;

    notification.show("processing command: '" + lastCmdType + ':' + lastCmdData + "'...");
    return true;
}

reader.onCommandFinish = function(ok, type, data)
{
    notification.show( "command "
        + ( ok? "successful"
                : ("'" + lastCmdType + ':' + lastCmdData + "' failed: " + type + ':' + data)
            )
        );
}

reader.onDecode = function(decode)
{
    notification.show("Decode ignored, scan again after done with configuration");
    return null;
}



// send/log

sendAndStoreOptions = new gui.Menu();
sendAndStoreOptions.caption = "Send/Log";
sendAndStoreOptions.changed = false;

sendAndStoreOptions.autoSend = new gui.ToggleButton
    ( "Always send"
    , true
    , function(checked, text)
      {
          var i = reader.readSetting(setting_sendStoreMode);

          if( checked )
              i &= ~noAutoSendBit;
          else
              i |=  noAutoSendBit;

          reader.writeSetting(setting_sendStoreMode, i);
          sendAndStoreOptions.changed = true;
      }
    );

sendAndStoreOptions.alwaysStore = new gui.ToggleButton
    ( "Always log"
    , false
    , function(checked, text)
      {
          var i = reader.readSetting(setting_sendStoreMode);

          if( checked )
              i |=  alwaysStoreBit;
          else
              i &= ~alwaysStoreBit;

          reader.writeSetting(setting_sendStoreMode, i);
          sendAndStoreOptions.changed = true;
      }
    );

sendAndStoreOptions.autoErase = new gui.ToggleButton
    ( "Auto erase"
    , true
    , function(checked, text)
      {
          reader.writeSetting(setting_autoLogErase, checked? 1: 0);
          sendAndStoreOptions.changed = true;
      }
    );

sendAndStoreOptions.autoUpload = new gui.ToggleButton
    ( "Auto upload"
    , true
    , function(checked, text)
      {
          reader.writeSetting(setting_autoBufferUpload, checked? 1: 0);
          sendAndStoreOptions.changed = true;
      }
    );

sendAndStoreOptions.append(sendAndStoreOptions.autoSend);
sendAndStoreOptions.append(sendAndStoreOptions.alwaysStore);
sendAndStoreOptions.append(sendAndStoreOptions.autoErase);
sendAndStoreOptions.append(sendAndStoreOptions.autoUpload);

sendAndStoreOptions.onKey = function(key)
{
    if( key == gui.key.back  ||  key == gui.key.escape )
    {
        if( this.changed && gui.confirm("Settings changed.\n\nSave now?") )
        {
            reader.saveSettings();
            reader.runScript(".default.js");
        }
    }
}

sendAndStoreOptions.update = function()
{
    sendAndStoreOptions.autoSend   .check(!(reader.readSetting(setting_sendStoreMode)    &  noAutoSendBit));
    sendAndStoreOptions.alwaysStore.check(  reader.readSetting(setting_sendStoreMode)    &  alwaysStoreBit);
    sendAndStoreOptions.autoErase  .check(  reader.readSetting(setting_autoLogErase)     != 0);
    sendAndStoreOptions.autoUpload .check(  reader.readSetting(setting_autoBufferUpload) != 0);

    this.changed = false;

    gui.showSubMenu(this, main);
}



// main
main.onCancel = function()
{
    reader.runScript(".default.js");
}

main.caption = "Configuration";
main.append( new gui.MenuItem("Application",     function() { gui.showSubMenu(main.app, main); }) );
main.append( new gui.MenuItem("Communication",   main.comm.interfaces_onClick) );
main.append( new gui.MenuItem("Send/Log",        function() { sendAndStoreOptions.update(); }) );
main.append( new gui.MenuItem("Reader Info",     function() { gui.showSubMenu(main.info, main); }) );
main.append( new gui.MenuItem("Optimization",    main.optimization_onClick) );
main.append( new gui.MenuItem("System",          function() { gui.showSubMenu(main.system, main); }) );

gui.showMenu(main);



// eof
