//jsSignatureStart[%14%d6%80%d8%fcY%f6%a7%fb%bc%f8%80%bf%8c%ed%f9%d6%ae%e0f`%0bN%25%8f{[%19%95%c1%d5I98%f4c%15W%8f*%e9%0fi%ba7%9b%d3t%ba>&%01%be%e1%093%19%f6*%d8%ba,%bc%b0%fb%f4{w!%08%04%c8%b3%c6%95%b2%02T%89z.%c3%db%09%be%ab%89Qe1E%b5%c8%f7%e7%16%0a%b7%14%8c<%8a%96%b9>%d9v5%e7`%02%83%9b%0a%92%d5%0d%a3%eaGLK%d1%b5%e7%c4r
/* .configure_main_comm_interface_usb.js
 *
 * $Source: /cygdrive/c/working/CodeCorp/Flipper/firmware/shared/jse/RCS/configure_main_comm_interface_usb.js,v $
 * $Revision: 1.14 $
 * $State: Exp $
 * $Name:  $
 *
 */



main.comm.interfaces.usb = new gui.Menu();

main.comm.interfaces.usb.kb_onClick = function()
{
    reader.processCommand("P", String.fromCharCode(commProtocol) + comm_raw);
    reader.processCommand("P", String.fromCharCode(commMode) + comm_usbKb);
    reader.processCommand("P", String.fromCharCode(commExpectResponse) + "0");
    main.comm.interfaces.promptSaveSetting(main.comm.interfaces.usb.initItemText);
}

main.comm.interfaces.usb.downloader_onClick = function()
{
    reader.processCommand("P", String.fromCharCode(commProtocol) + comm_raw);
    reader.processCommand("P", String.fromCharCode(commMode) + comm_usbNative);
    reader.processCommand("P", String.fromCharCode(commExpectResponse) + "0");
    main.comm.interfaces.promptSaveSetting(main.comm.interfaces.usb.initItemText);
}

main.comm.interfaces.usb.twoWay_onClick = function()
{
    reader.processCommand("P", String.fromCharCode(commProtocol) + comm_version0);
    reader.processCommand("P", String.fromCharCode(commMode) + comm_usbNative);
    reader.processCommand("P", String.fromCharCode(commExpectResponse) + "1");
    main.comm.interfaces.promptSaveSetting(main.comm.interfaces.usb.initItemText);
}

main.comm.interfaces.usb.vcom1way_onClick = function()
{
    reader.processCommand("P", String.fromCharCode(commProtocol) + comm_raw);
    reader.processCommand("P", String.fromCharCode(commMode) + comm_usbVcom);
    reader.processCommand("P", String.fromCharCode(commExpectResponse) + "0");
    main.comm.interfaces.promptSaveSetting(main.comm.interfaces.usb.initItemText);
}

main.comm.interfaces.usb.kb = new gui.MenuItem("", main.comm.interfaces.usb.kb_onClick);
main.comm.interfaces.usb.downloader = new gui.MenuItem("", main.comm.interfaces.usb.downloader_onClick);
main.comm.interfaces.usb.twoWay = new gui.MenuItem("", main.comm.interfaces.usb.twoWay_onClick);
main.comm.interfaces.usb.vcom1way = new gui.MenuItem("", main.comm.interfaces.usb.vcom1way_onClick);

main.comm.interfaces.usb.append(main.comm.interfaces.usb.kb);
main.comm.interfaces.usb.append(main.comm.interfaces.usb.downloader);
main.comm.interfaces.usb.append(main.comm.interfaces.usb.twoWay);
main.comm.interfaces.usb.append(main.comm.interfaces.usb.vcom1way);

main.comm.interfaces.usb.initItemText = function()
{
    if( reader.readSetting(commMode) == comm_usbKb )
    {
        main.comm.interfaces.usb.kb.text         = "*"    + "Keyboard";
        main.comm.interfaces.usb.downloader.text = "\x1f" + "Downloader";
        main.comm.interfaces.usb.twoWay.text     = "\x1f" + "Native 2way";
        main.comm.interfaces.usb.vcom1way.text   = "\x1f" + "VCOM 1way";
    }
    else if( reader.readSetting(commMode) == comm_usbNative && reader.readSetting(commProtocol) == comm_raw )
    {
        main.comm.interfaces.usb.kb.text         = "\x1f" + "Keyboard";
        main.comm.interfaces.usb.downloader.text = "*"    + "Downloader";
        main.comm.interfaces.usb.twoWay.text     = "\x1f" + "Native 2way";
        main.comm.interfaces.usb.vcom1way.text   = "\x1f" + "VCOM 1way";
    }
    else if( reader.readSetting(commMode) == comm_usbNative && reader.readSetting(commProtocol) != comm_raw )
    {
        main.comm.interfaces.usb.kb.text         = "\x1f" + "Keyboard";
        main.comm.interfaces.usb.downloader.text = "\x1f" + "Downloader";
        main.comm.interfaces.usb.twoWay.text     = "*"    + "Native 2way";
        main.comm.interfaces.usb.vcom1way.text   = "\x1f" + "VCOM 1way";
    }
    else if( reader.readSetting(commMode) == comm_usbVcom && reader.readSetting(commProtocol) == comm_raw  )
    {
        main.comm.interfaces.usb.kb.text         = "\x1f" + "Keyboard";
        main.comm.interfaces.usb.downloader.text = "\x1f" + "Downloader";
        main.comm.interfaces.usb.twoWay.text     = "\x1f" + "Native 2way";
        main.comm.interfaces.usb.vcom1way.text   = "*"    + "VCOM 1way";
    }
    else 
    {
        main.comm.interfaces.usb.kb.text         = "\x1f" + "Keyboard";
        main.comm.interfaces.usb.downloader.text = "\x1f" + "Downloader";
        main.comm.interfaces.usb.twoWay.text     = "\x1f" + "Native 2way";
        main.comm.interfaces.usb.vcom1way.text   = "\x1f" + "VCOM 1way";
    }
}



